Index: /trunk/kBuild/sdks/MACOSX1010.kmk
===================================================================
--- /trunk/kBuild/sdks/MACOSX1010.kmk	(revision 3405)
+++ /trunk/kBuild/sdks/MACOSX1010.kmk	(revision 3406)
@@ -54,8 +54,9 @@
 # General Properties (used by kBuild)
 # Note: The MAC_OS_X_VERSION_MAX_ALLOWED is left free for the SDK user to define.
-SDK_MACOSX1010_DEFS      ?= MAC_OS_X_VERSION_MIN_REQUIRED=101000
-SDK_MACOSX1010_CFLAGS    ?= -mmacosx-version-min=10.10 -isysroot $(PATH_SDK_MACOSX1010)
-SDK_MACOSX1010_CXXFLAGS  ?= -mmacosx-version-min=10.10 -isysroot $(PATH_SDK_MACOSX1010)
-SDK_MACOSX1010_OBJCFLAGS ?= -mmacosx-version-min=10.10 -isysroot $(PATH_SDK_MACOSX1010)
-SDK_MACOSX1010_LDFLAGS   ?= -mmacosx-version-min=10.10 -isysroot $(PATH_SDK_MACOSX1010)
+SDK_MACOSX1010_DEFS        ?= MAC_OS_X_VERSION_MIN_REQUIRED=101000
+SDK_MACOSX1010_CFLAGS      ?= -mmacosx-version-min=10.10 -isysroot $(PATH_SDK_MACOSX1010)
+SDK_MACOSX1010_CXXFLAGS    ?= -mmacosx-version-min=10.10 -isysroot $(PATH_SDK_MACOSX1010)
+SDK_MACOSX1010_OBJCFLAGS   ?= -mmacosx-version-min=10.10 -isysroot $(PATH_SDK_MACOSX1010)
+SDK_MACOSX1010_OBJCXXFLAGS ?= -mmacosx-version-min=10.10 -isysroot $(PATH_SDK_MACOSX1010)
+SDK_MACOSX1010_LDFLAGS     ?= -mmacosx-version-min=10.10 -isysroot $(PATH_SDK_MACOSX1010)
 
Index: /trunk/kBuild/sdks/MACOSX1013.kmk
===================================================================
--- /trunk/kBuild/sdks/MACOSX1013.kmk	(revision 3405)
+++ /trunk/kBuild/sdks/MACOSX1013.kmk	(revision 3406)
@@ -54,8 +54,9 @@
 # General Properties (used by kBuild)
 # Note: The MAC_OS_X_VERSION_MAX_ALLOWED is left free for the SDK user to define.
-SDK_MACOSX1013_DEFS      ?= MAC_OS_X_VERSION_MIN_REQUIRED=101300
-SDK_MACOSX1013_CFLAGS    ?= -mmacosx-version-min=10.13 -isysroot $(PATH_SDK_MACOSX1013)
-SDK_MACOSX1013_CXXFLAGS  ?= -mmacosx-version-min=10.13 -isysroot $(PATH_SDK_MACOSX1013)
-SDK_MACOSX1013_OBJCFLAGS ?= -mmacosx-version-min=10.13 -isysroot $(PATH_SDK_MACOSX1013)
-SDK_MACOSX1013_LDFLAGS   ?= -mmacosx-version-min=10.13 -isysroot $(PATH_SDK_MACOSX1013)
+SDK_MACOSX1013_DEFS        ?= MAC_OS_X_VERSION_MIN_REQUIRED=101300
+SDK_MACOSX1013_CFLAGS      ?= -mmacosx-version-min=10.13 -isysroot $(PATH_SDK_MACOSX1013)
+SDK_MACOSX1013_CXXFLAGS    ?= -mmacosx-version-min=10.13 -isysroot $(PATH_SDK_MACOSX1013)
+SDK_MACOSX1013_OBJCFLAGS   ?= -mmacosx-version-min=10.13 -isysroot $(PATH_SDK_MACOSX1013)
+SDK_MACOSX1013_OBJCXXFLAGS ?= -mmacosx-version-min=10.13 -isysroot $(PATH_SDK_MACOSX1013)
+SDK_MACOSX1013_LDFLAGS     ?= -mmacosx-version-min=10.13 -isysroot $(PATH_SDK_MACOSX1013)
 
Index: /trunk/kBuild/sdks/MACOSX104.kmk
===================================================================
--- /trunk/kBuild/sdks/MACOSX104.kmk	(revision 3405)
+++ /trunk/kBuild/sdks/MACOSX104.kmk	(revision 3406)
@@ -44,8 +44,9 @@
 # General Properties (used by kBuild)
 # Note: The MAC_OS_X_VERSION_MAX_ALLOWED is left free for the SDK user to define.
-SDK_MACOSX104_DEFS      ?= MAC_OS_X_VERSION_MIN_REQUIRED=1040
-SDK_MACOSX104_CFLAGS    ?= -mmacosx-version-min=10.4 -isysroot $(PATH_SDK_MACOSX104)
-SDK_MACOSX104_CXXFLAGS  ?= -mmacosx-version-min=10.4 -isysroot $(PATH_SDK_MACOSX104)
-SDK_MACOSX104_OBJCFLAGS ?= -mmacosx-version-min=10.4 -isysroot $(PATH_SDK_MACOSX104)
-SDK_MACOSX104_LDFLAGS   ?= -mmacosx-version-min=10.4 -Wl,-syslibroot,$(PATH_SDK_MACOSX104)
+SDK_MACOSX104_DEFS        ?= MAC_OS_X_VERSION_MIN_REQUIRED=1040
+SDK_MACOSX104_CFLAGS      ?= -mmacosx-version-min=10.4 -isysroot $(PATH_SDK_MACOSX104)
+SDK_MACOSX104_CXXFLAGS    ?= -mmacosx-version-min=10.4 -isysroot $(PATH_SDK_MACOSX104)
+SDK_MACOSX104_OBJCFLAGS   ?= -mmacosx-version-min=10.4 -isysroot $(PATH_SDK_MACOSX104)
+SDK_MACOSX104_OBJCXXFLAGS ?= -mmacosx-version-min=10.4 -isysroot $(PATH_SDK_MACOSX104)
+SDK_MACOSX104_LDFLAGS     ?= -mmacosx-version-min=10.4 -Wl,-syslibroot,$(PATH_SDK_MACOSX104)
 
Index: /trunk/kBuild/sdks/MACOSX105.kmk
===================================================================
--- /trunk/kBuild/sdks/MACOSX105.kmk	(revision 3405)
+++ /trunk/kBuild/sdks/MACOSX105.kmk	(revision 3406)
@@ -44,8 +44,9 @@
 # General Properties (used by kBuild)
 # Note: The MAC_OS_X_VERSION_MAX_ALLOWED is left free for the SDK user to define.
-SDK_MACOSX105_DEFS      ?= MAC_OS_X_VERSION_MIN_REQUIRED=1050
-SDK_MACOSX105_CFLAGS    ?= -mmacosx-version-min=10.5 -isysroot $(PATH_SDK_MACOSX105)
-SDK_MACOSX105_CXXFLAGS  ?= -mmacosx-version-min=10.5 -isysroot $(PATH_SDK_MACOSX105)
-SDK_MACOSX105_OBJCFLAGS ?= -mmacosx-version-min=10.5 -isysroot $(PATH_SDK_MACOSX105)
-SDK_MACOSX105_LDFLAGS   ?= -mmacosx-version-min=10.5 -Wl,-syslibroot,$(PATH_SDK_MACOSX105)
+SDK_MACOSX105_DEFS        ?= MAC_OS_X_VERSION_MIN_REQUIRED=1050
+SDK_MACOSX105_CFLAGS      ?= -mmacosx-version-min=10.5 -isysroot $(PATH_SDK_MACOSX105)
+SDK_MACOSX105_CXXFLAGS    ?= -mmacosx-version-min=10.5 -isysroot $(PATH_SDK_MACOSX105)
+SDK_MACOSX105_OBJCFLAGS   ?= -mmacosx-version-min=10.5 -isysroot $(PATH_SDK_MACOSX105)
+SDK_MACOSX105_OBJCXXFLAGS ?= -mmacosx-version-min=10.5 -isysroot $(PATH_SDK_MACOSX105)
+SDK_MACOSX105_LDFLAGS     ?= -mmacosx-version-min=10.5 -Wl,-syslibroot,$(PATH_SDK_MACOSX105)
 