Index: trunk/kBuild/sdks/MACOSX1014.kmk
===================================================================
--- trunk/kBuild/sdks/MACOSX1014.kmk	(revision 3407)
+++ trunk/kBuild/sdks/MACOSX1014.kmk	(revision 3407)
@@ -0,0 +1,62 @@
+# $Id$
+## @file
+# kBuild SDK - Mac OS X v10.14 SDK.
+#
+
+#
+# Copyright (c) 2008-2020 knut st. osmundsen <bird-kBuild-spam-xx@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+ifndef INCLUDED_DARWIN_COMMON_KMK
+ include $(KBUILD_PATH)/darwin-common.kmk
+endif
+
+SDK_MACOSX1014 := Mac OS X v10.14 SDK
+
+# SDK Specific Properties
+ifndef PATH_SDK_MACOSX1014
+ PATH_SDK_MACOSX1014 := $(call DARWINCMN_FN_FIND_MACOSX_SDK,MacOSX10.14.sdk)
+else
+ # Resolve any fancy stuff once and for all.
+ PATH_SDK_MACOSX1014 := $(PATH_SDK_MACOSX1014)
+endif
+ifeq ($(PATH_SDK_MACOSX1014),)
+ $(warning $(call DARWINCMN_FN_ERROR_MACOSX_SDK,MacOSX10.14.sdk))
+endif
+
+## The MAC_OS_X_VERSION_MIN_REQUIRED and MAC_OS_X_VERSION_MAX_ALLOWED value for this SDK.
+SDK_MACOSX1014_VERSION_VALUE := 101400
+
+# General Properties (used by kBuild)
+# Note: The MAC_OS_X_VERSION_MAX_ALLOWED is left free for the SDK user to define.
+SDK_MACOSX1014_DEFS        ?= MAC_OS_X_VERSION_MIN_REQUIRED=101400
+SDK_MACOSX1014_CFLAGS      ?= -mmacosx-version-min=10.14 -isysroot $(PATH_SDK_MACOSX1014)
+SDK_MACOSX1014_CXXFLAGS    ?= -mmacosx-version-min=10.14 -isysroot $(PATH_SDK_MACOSX1014)
+SDK_MACOSX1014_OBJCFLAGS   ?= -mmacosx-version-min=10.14 -isysroot $(PATH_SDK_MACOSX1014)
+SDK_MACOSX1014_OBJCXXFLAGS ?= -mmacosx-version-min=10.14 -isysroot $(PATH_SDK_MACOSX1014)
+SDK_MACOSX1014_LDFLAGS     ?= -mmacosx-version-min=10.14 -isysroot $(PATH_SDK_MACOSX1014)
+
Index: trunk/kBuild/sdks/MACOSX1014INCS.kmk
===================================================================
--- trunk/kBuild/sdks/MACOSX1014INCS.kmk	(revision 3407)
+++ trunk/kBuild/sdks/MACOSX1014INCS.kmk	(revision 3407)
@@ -0,0 +1,49 @@
+# $Id$
+## @file
+# kBuild SDK - Mac OS X v10.14 SDK, includes only.
+#
+
+#
+# Copyright (c) 2008-2020 knut st. osmundsen <bird-kBuild-spam-xx@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+ifndef SDK_MACOSX1014
+ include $(KBUILD_PATH)/sdks/MACOSX1014.kmk
+endif
+
+SDK_MACOSX1014INCS := Mac OS X v10.14 SDK, include only.
+
+# SDK Specific Properties
+ifndef PATH_SDK_MACOSX1014INCS
+ PATH_SDK_MACOSX1014INCS := $(PATH_SDK_MACOSX1014)
+else
+ PATH_SDK_MACOSX1014INCS := $(PATH_SDK_MACOSX1014INCS)
+endif
+
+# General Properties (used by kBuild)
+SDK_MACOSX1014INCS_INCS = $(PATH_SDK_MACOSX1014INCS)/usr/include
+
Index: trunk/kBuild/sdks/MACOSX1015.kmk
===================================================================
--- trunk/kBuild/sdks/MACOSX1015.kmk	(revision 3407)
+++ trunk/kBuild/sdks/MACOSX1015.kmk	(revision 3407)
@@ -0,0 +1,62 @@
+# $Id$
+## @file
+# kBuild SDK - Mac OS X v10.15 SDK.
+#
+
+#
+# Copyright (c) 2008-2020 knut st. osmundsen <bird-kBuild-spam-xx@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+ifndef INCLUDED_DARWIN_COMMON_KMK
+ include $(KBUILD_PATH)/darwin-common.kmk
+endif
+
+SDK_MACOSX1015 := Mac OS X v10.15 SDK
+
+# SDK Specific Properties
+ifndef PATH_SDK_MACOSX1015
+ PATH_SDK_MACOSX1015 := $(call DARWINCMN_FN_FIND_MACOSX_SDK,MacOSX10.15.sdk)
+else
+ # Resolve any fancy stuff once and for all.
+ PATH_SDK_MACOSX1015 := $(PATH_SDK_MACOSX1015)
+endif
+ifeq ($(PATH_SDK_MACOSX1015),)
+ $(warning $(call DARWINCMN_FN_ERROR_MACOSX_SDK,MacOSX10.15.sdk))
+endif
+
+## The MAC_OS_X_VERSION_MIN_REQUIRED and MAC_OS_X_VERSION_MAX_ALLOWED value for this SDK.
+SDK_MACOSX1015_VERSION_VALUE := 101500
+
+# General Properties (used by kBuild)
+# Note: The MAC_OS_X_VERSION_MAX_ALLOWED is left free for the SDK user to define.
+SDK_MACOSX1015_DEFS        ?= MAC_OS_X_VERSION_MIN_REQUIRED=101500
+SDK_MACOSX1015_CFLAGS      ?= -mmacosx-version-min=10.15 -isysroot $(PATH_SDK_MACOSX1015)
+SDK_MACOSX1015_CXXFLAGS    ?= -mmacosx-version-min=10.15 -isysroot $(PATH_SDK_MACOSX1015)
+SDK_MACOSX1015_OBJCFLAGS   ?= -mmacosx-version-min=10.15 -isysroot $(PATH_SDK_MACOSX1015)
+SDK_MACOSX1015_OBJCXXFLAGS ?= -mmacosx-version-min=10.15 -isysroot $(PATH_SDK_MACOSX1015)
+SDK_MACOSX1015_LDFLAGS     ?= -mmacosx-version-min=10.15 -isysroot $(PATH_SDK_MACOSX1015)
+
Index: trunk/kBuild/sdks/MACOSX1015INCS.kmk
===================================================================
--- trunk/kBuild/sdks/MACOSX1015INCS.kmk	(revision 3407)
+++ trunk/kBuild/sdks/MACOSX1015INCS.kmk	(revision 3407)
@@ -0,0 +1,49 @@
+# $Id$
+## @file
+# kBuild SDK - Mac OS X v10.15 SDK, includes only.
+#
+
+#
+# Copyright (c) 2008-2020 knut st. osmundsen <bird-kBuild-spam-xx@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+ifndef SDK_MACOSX1015
+ include $(KBUILD_PATH)/sdks/MACOSX1015.kmk
+endif
+
+SDK_MACOSX1015INCS := Mac OS X v10.15 SDK, include only.
+
+# SDK Specific Properties
+ifndef PATH_SDK_MACOSX1015INCS
+ PATH_SDK_MACOSX1015INCS := $(PATH_SDK_MACOSX1015)
+else
+ PATH_SDK_MACOSX1015INCS := $(PATH_SDK_MACOSX1015INCS)
+endif
+
+# General Properties (used by kBuild)
+SDK_MACOSX1015INCS_INCS = $(PATH_SDK_MACOSX1015INCS)/usr/include
+