Index: trunk/src/comctl32/CCBase.cpp
===================================================================
--- trunk/src/comctl32/CCBase.cpp	(revision 3409)
+++ trunk/src/comctl32/CCBase.cpp	(revision 3410)
@@ -1,3 +1,3 @@
-/* $Id: CCBase.cpp,v 1.8 2000-04-16 18:26:55 cbratschi Exp $ */
+/* $Id: CCBase.cpp,v 1.9 2000-04-16 18:52:38 cbratschi Exp $ */
 /*
  * COMCTL32 Base Functions and Macros for all Controls
@@ -7,5 +7,4 @@
  * parts from WINE code
  */
-
 #include <string.h>
 #include <wcstr.h>
Index: trunk/src/comctl32/CCBase.h
===================================================================
--- trunk/src/comctl32/CCBase.h	(revision 3409)
+++ trunk/src/comctl32/CCBase.h	(revision 3410)
@@ -1,3 +1,3 @@
-/* $Id: CCBase.h,v 1.9 2000-04-16 18:26:56 cbratschi Exp $ */
+/* $Id: CCBase.h,v 1.10 2000-04-16 18:52:38 cbratschi Exp $ */
 /*
  * COMCTL32 Base Functions and Macros for all Controls
@@ -53,5 +53,5 @@
 INT lstrcmpAW(WCHAR *textA,BOOL textaunicode,WCHAR *textB,BOOL textbunicode);
 
-//read note in CCBase.cpp!
+//read note in CCBase.cpp!!
 INT lstrcmpniA(CHAR *textA,CHAR *textB,INT len);
 INT lstrcmpniAtoW(CHAR *textA,WCHAR* textB,INT len);
Index: trunk/src/comctl32/comctl32.cpp
===================================================================
--- trunk/src/comctl32/comctl32.cpp	(revision 3409)
+++ trunk/src/comctl32/comctl32.cpp	(revision 3410)
@@ -1,3 +1,3 @@
-/* $Id: comctl32.cpp,v 1.2 2000-04-16 18:26:57 cbratschi Exp $ */
+/* $Id: comctl32.cpp,v 1.3 2000-04-16 18:52:38 cbratschi Exp $ */
 /*
  * Win32 common controls implementation
@@ -132,5 +132,4 @@
  *     (will be written ...)
  */
-
 VOID WINAPI
 MenuHelp (UINT uMsg, WPARAM wParam, LPARAM lParam, HMENU hMainMenu,
Index: trunk/src/comctl32/comctl32.h
===================================================================
--- trunk/src/comctl32/comctl32.h	(revision 3409)
+++ trunk/src/comctl32/comctl32.h	(revision 3410)
@@ -1,3 +1,3 @@
-/* $Id: comctl32.h,v 1.13 2000-04-16 18:26:57 cbratschi Exp $ */
+/* $Id: comctl32.h,v 1.14 2000-04-16 18:52:39 cbratschi Exp $ */
 /*
  * Win32 common controls implementation
@@ -38,5 +38,4 @@
 }
 #endif
-
 
 // string functions from kernel32
Index: trunk/src/comctl32/header.cpp
===================================================================
--- trunk/src/comctl32/header.cpp	(revision 3409)
+++ trunk/src/comctl32/header.cpp	(revision 3410)
@@ -1,3 +1,3 @@
-/* $Id: header.cpp,v 1.7 2000-04-16 18:26:57 cbratschi Exp $ */
+/* $Id: header.cpp,v 1.8 2000-04-16 18:52:39 cbratschi Exp $ */
 /*
  *  Header control
@@ -1619,5 +1619,5 @@
 HEADER_LButtonDown (HWND hwnd, WPARAM wParam, LPARAM lParam)
 {
-    HEADER_INFO *infoPtr = HEADER_GetInfoPtr (hwnd);
+    HEADER_INFO *infoPtr = HEADER_GetInfoPtr(hwnd);
     DWORD dwStyle = GetWindowLongA (hwnd, GWL_STYLE);
     POINT pt;
Index: trunk/src/comctl32/listview.cpp
===================================================================
--- trunk/src/comctl32/listview.cpp	(revision 3409)
+++ trunk/src/comctl32/listview.cpp	(revision 3410)
@@ -1,3 +1,3 @@
-/*$Id: listview.cpp,v 1.14 2000-04-16 18:26:57 cbratschi Exp $*/
+/*$Id: listview.cpp,v 1.15 2000-04-16 18:52:39 cbratschi Exp $*/
 /*
  * Listview control
@@ -3302,5 +3302,5 @@
 static UINT LISTVIEW_GetCallbackMask(HWND hwnd)
 {
-  LISTVIEW_INFO *infoPtr = (LISTVIEW_INFO *)LISTVIEW_GetInfoPtr(hwnd);
+  LISTVIEW_INFO *infoPtr = (LISTVIEW_INFO*)LISTVIEW_GetInfoPtr(hwnd);
 
   return infoPtr->uCallbackMask;
Index: trunk/src/comctl32/rsrc.orc
===================================================================
--- trunk/src/comctl32/rsrc.orc	(revision 3409)
+++ trunk/src/comctl32/rsrc.orc	(revision 3410)
@@ -1,3 +1,3 @@
-/* $Id: rsrc.orc,v 1.4 2000-04-16 18:26:59 cbratschi Exp $ */
+/* $Id: rsrc.orc,v 1.5 2000-04-16 18:52:40 cbratschi Exp $ */
 #include "winuser.h"
 #include "comctl32.h"
@@ -1153,4 +1153,5 @@
 #define IDC_COMCTL32_DIRECTION_SW  119
 
+
 #define IDC_COMCTL32_SPLITVLINE    135
 #define IDC_COMCTL32_ENTER         150
Index: trunk/src/comctl32/treeview.cpp
===================================================================
--- trunk/src/comctl32/treeview.cpp	(revision 3409)
+++ trunk/src/comctl32/treeview.cpp	(revision 3410)
@@ -1,3 +1,3 @@
-/* $Id: treeview.cpp,v 1.10 2000-04-16 18:26:59 cbratschi Exp $ */
+/* $Id: treeview.cpp,v 1.11 2000-04-16 18:48:53 cbratschi Exp $ */
 /* Treeview control
  *
@@ -5278,3 +5278,2 @@
     UnregisterClassA (WC_TREEVIEWA, (HINSTANCE)NULL);
 }
-