Index: /trunk/kNIXPortage/profiles/arch.list
===================================================================
--- /trunk/kNIXPortage/profiles/arch.list	(revision 3434)
+++ /trunk/kNIXPortage/profiles/arch.list	(revision 3434)
@@ -0,0 +1,17 @@
+alpha
+amd64
+arm
+hppa
+ia64
+m68k
+mips
+ppc
+ppc64
+ppc-macos
+s390
+sh
+sparc
+sparc-fbsd
+x86
+x86-fbsd
+x86-os2
Index: /trunk/kNIXPortage/profiles/default-knix/make.defaults
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/make.defaults	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/make.defaults	(revision 3434)
@@ -0,0 +1,17 @@
+# Copyright 2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header$
+
+# System-wide defaults for all kNIX profiles
+
+CFLAGS="-O2 -no-omit-frame-pointers"
+CXXFLAGS="${CFLAGS}"
+
+FEATURES="-sandbox -userpriv"
+
+USE="-nls"
+USE_EXPAND="USERLAND KERNEL ELIBC"
+USERLAND="GNU"
+KERNEL="kNIX"
+ELIBC="kLIBC"
+
Index: /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/make.defaults
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/make.defaults	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/make.defaults	(revision 3434)
@@ -0,0 +1,6 @@
+# Copyright 2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header$
+
+# XXX: good idea? just copying from the Mac OS X profile...
+FEATURES="collision-protect"
Index: /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/package.mask
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/package.mask	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/package.mask	(revision 3434)
@@ -0,0 +1,4 @@
+# Copyright 2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header$
+
Index: /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/package.provided
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/package.provided	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/package.provided	(revision 3434)
@@ -0,0 +1,5 @@
+# Copyright 2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header$
+
+
Index: /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/packages
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/packages	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/packages	(revision 3434)
@@ -0,0 +1,18 @@
+# Copyright 2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header$
+
+## Begin Linux specific packages
+-*sys-apps/kbd
+-*sys-apps/net-tools
+-*sys-process/procps
+-*sys-process/psmisc
+-*net-misc/iputils
+-*sys-apps/shadow
+-*sys-apps/which
+-*sys-fs/e2fsprogs
+-*virtual/dev-manager
+-*virtual/man
+-*virtual/modutils
+## End Linux specific packages
+
Index: /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/parent
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/parent	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/parent	(revision 3434)
@@ -0,0 +1,1 @@
+..
Index: /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/profile.bashrc
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/profile.bashrc	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/profile.bashrc	(revision 3434)
@@ -0,0 +1,5 @@
+# Copyright 2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header$
+
+
Index: /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/use.mask
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/use.mask	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/os2/2007.0/use.mask	(revision 3434)
@@ -0,0 +1,62 @@
+# Copyright 2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header$
+
+
+# The following is a modified default-darwin/macos/10.4/use.mask:
+
+# tcl ebuild overwrites Apple's tcl, so we mask it (dev-lang/ruby)
+tcltk
+tcl
+tk
+
+# Collision-protect
+a52
+
+# gtk+ pulls in XML-Parser with USE="nls xml", so Perl issue should
+# be resolved first before keywording them
+gtk
+gtk2
+
+# imlib depends on gtk+-1
+imlib
+
+# rxvt-unicode's tabs requires dev-perl/gtk2-perl
+tabs
+
+# wxwindows needs wxGTK which in turn needs gtk+
+wxwindows
+
+# see GCC man-page (-static): "This option will not work on Mac OS X..."
+static
+
+# pulls libidn, which has problems with java-config
+idn
+
+# OSX has pam, but openvpn doesn't compile against it (yet?)
+pam
+
+# needs keywording
+avahi
+physfs
+
+# libfpx doesn't compile, see bug #103269
+fpx
+
+# gnutls has collisions
+gnutls
+
+# libprelude depends on gnutls which is h0rkened for now
+prelude
+
+# pike doesn't link for some reason #109649
+pike
+
+# xattr pulls in some deps that probably won't ever fly on OSX #121092
+xattr
+
+# portage uses it, we don't keyword it
+epydoc
+
+# fluxbox's nls pulls in gettext
+nls
Index: /trunk/kNIXPortage/profiles/default-knix/os2/make.defaults
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/os2/make.defaults	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/os2/make.defaults	(revision 3434)
@@ -0,0 +1,11 @@
+# Copyright 2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header$
+
+# System-wide defaults for all x86-os2 profiles
+
+ARCH="x86"
+ACCEPT_KEYWORDS="x86-os2"
+USE="x86-os2 -nls"
+LDFLAGS="-Zomf"
+CHOST="i386-pc-os2-knix"
Index: /trunk/kNIXPortage/profiles/default-knix/os2/package.mask
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/os2/package.mask	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/os2/package.mask	(revision 3434)
@@ -0,0 +1,5 @@
+# Copyright 2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header$
+
+
Index: /trunk/kNIXPortage/profiles/default-knix/os2/parent
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/os2/parent	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/os2/parent	(revision 3434)
@@ -0,0 +1,1 @@
+..
Index: /trunk/kNIXPortage/profiles/default-knix/os2/use.mask
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/os2/use.mask	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/os2/use.mask	(revision 3434)
@@ -0,0 +1,33 @@
+# Copyright 2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header$
+
+# Add USE flags that don't work on OS/2 here
+
+# This is from default-darwin/macos:
+
+# needs a lot of packages ported before its usable.
+xemacs
+smartcard
+
+# Requires non-apple hardware, so at least until x86-macos, we won't be able to test these.
+i8x0
+matrox
+
+# Masked until we can get these ported.
+dts
+dvb
+ieee1394
+lirc
+live
+mpi
+mysql
+sasl
+
+# OSX doesn't have much of a console, so a driver for it won't be that
+# useful, same for framebuffered version
+gpm
+fbcon
+
+nls
+
Index: /trunk/kNIXPortage/profiles/default-knix/os2/virtuals
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/os2/virtuals	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/os2/virtuals	(revision 3434)
@@ -0,0 +1,8 @@
+# Copyright 2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header$
+
+# Use this virtuals file to either override the kNIX base profile's defined
+# virtuals, or add virtuals that are specific to the OS/2 profiles.
+
+
Index: /trunk/kNIXPortage/profiles/default-knix/package.mask
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/package.mask	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/package.mask	(revision 3434)
@@ -0,0 +1,5 @@
+# Copyright 2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header$
+
+
Index: /trunk/kNIXPortage/profiles/default-knix/package.provided
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/package.provided	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/package.provided	(revision 3434)
@@ -0,0 +1,9 @@
+# Copyright 2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header$
+
+# Current set up libc, gcc and stuff as provided...
+sys-libs/kLIBC-0.6.3
+sys-devel/gcc-3.3.5
+sys-devel/binutils-2.14
+
Index: /trunk/kNIXPortage/profiles/default-knix/packages
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/packages	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/packages	(revision 3434)
@@ -0,0 +1,8 @@
+# Copyright 2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header$
+
+# Things we want emerge system to install for all kNIX profiles
+
+*sys-apps/sed
+
Index: /trunk/kNIXPortage/profiles/default-knix/parent
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/parent	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/parent	(revision 3434)
@@ -0,0 +1,2 @@
+#../base
+/@unixroot/usr/portage/profiles/base
Index: /trunk/kNIXPortage/profiles/default-knix/use.force
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/use.force	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/use.force	(revision 3434)
@@ -0,0 +1,8 @@
+# Copyright 2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header$
+
+# Force the kNIX ELIBC, KERNEL and USERLAND.
+elibc_kLIBC
+kernel_kNIX
+userland_GNU
Index: /trunk/kNIXPortage/profiles/default-knix/use.mask
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/use.mask	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/use.mask	(revision 3434)
@@ -0,0 +1,69 @@
+# Copyright 2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header$
+
+# Add USE flags that don't work on kNIX here
+
+# Re-add kNIX libc & kernel and mask extraneous elibc/kernel combinations.
+-elibc_kLIBC
+-kernel_kNIX
+elibc_glibc
+kernel_linux
+
+# The following is from default-darwin/use.mask:
+
+3dfx
+acpi
+alsa
+apm
+cap
+caps
+directfb
+djbfft
+emul-linux-x86
+fbcon
+fmod
+ggi
+gpm
+hardened
+# VV requires device-mapper 
+on-the-fly-crypt
+oss
+rtc
+voodoo3
+pvm
+v4l
+v4l2
+
+# need porting
+acl
+apache2
+arts
+cjk
+doc
+esd
+gnome
+jack-tmpfs
+kde
+libcaca
+mikmod
+mono
+mzscheme
+nas
+pike
+qdbm
+socks5
+xmms
+
+# see email to gentoo-dev with subject "use.mask and PHP5's crazy IUSE"
+# Dated Sat, 31 Jul 2004 14:49:28 -0700, from robbat2@gentoo.org
+# all of these are binary-only, and not presently available on this
+# architecture.
+
+# masks for x11-libs/qt
+odbc
+postgres
+
+# breaks clisp builds
+fastcgi
+
Index: /trunk/kNIXPortage/profiles/default-knix/virtuals
===================================================================
--- /trunk/kNIXPortage/profiles/default-knix/virtuals	(revision 3434)
+++ /trunk/kNIXPortage/profiles/default-knix/virtuals	(revision 3434)
@@ -0,0 +1,27 @@
+# Copyright 2007 Gentoo Foundation.
+# Distributed under the terms of the GNU General Public License v2
+# $Header$
+
+# virtual/os-headers should actually be sys-kernel/xnu
+# but we have to wait until its in the tree
+
+virtual/aspell-dict	app-dicts/aspell-en
+virtual/baselayout	sys-apps/baselayout
+#virtual/bootloader	os/arch specific
+virtual/commonlisp	dev-lisp/sbcl
+virtual/cron		sys-process/vixie-cron
+virtual/dhcpcd		net-misc/dhcpcd
+virtual/editor		app-editors/joe
+virtual/inetd		sys-apps/xinetd
+virtual/krb5		app-crypt/mit-krb5
+virtual/libc		sys-libs/kLIBC
+virtual/logger		app-admin/sysklogd
+virtual/lpr			net-print/cups
+virtual/mda			mail-filter/procmail
+virtual/mta			mail-mta/postfix
+#virtual/os-headers	os/arch specific
+virtual/python		dev-lang/python
+virtual/ruby		dev-lang/ruby
+virtual/ssh			net-misc/openssh
+virtual/tetex		app-text/tetex
+virtual/w3m			www-client/w3m